<?php

use Illuminate\Foundation\Application;
use Illuminate\Foundation\Configuration\Exceptions;
use Illuminate\Foundation\Configuration\Middleware;
use Illuminate\Console\Scheduling\Schedule;
use App\Http\Middleware\SetUserLanguage;
use App\Http\Middleware\CheckPermission;
use App\Http\Middleware\PerformanceMonitor;
use Laravel\Sanctum\Http\Middleware\CheckForAnyAbility;
use App\Tasks\DeleteExpiredTokens;


return Application::configure(basePath: dirname(__DIR__))
    ->withRouting(
        web: __DIR__ . '/../routes/web.php',
        api: __DIR__ . '/../routes/api.php',
        commands: __DIR__ . '/../routes/console.php',
        health: '/up',
    )
    ->withMiddleware(function (Middleware $middleware) {
        // $middleware->statefulApi();
        $middleware->append([SetUserLanguage::class, PerformanceMonitor::class]);
        $middleware->alias([
            'permission' => CheckPermission::class,
            'ability' => CheckForAnyAbility::class,
        ]);
    })
    ->withSchedule(function (Schedule $schedule) {
        $schedule->call(new DeleteExpiredTokens)->everyMinute();
    })
    ->withExceptions(function (Exceptions $exceptions) {
        //
    })
    ->create();
